accounts/urls.py
# accounts/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required

from . import views
from accounts import views as user_views

app_name = 'account'
urlpatterns = [
    path('signup/', views.SignUp.as_view(), name='signup'),
	path('profile/', user_views.profile, name='profile'),
	path('load_profile_picture/', user_views.loadProfilePicture, name='load_profile_picture'),
]

gestion_projets/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required

from .views import *

app_name = 'gestion_projets'
urlpatterns = [
    # Subjects Views
    path('subjects/', login_required(views_subjects.SubjectsView.as_view()), name='subject_list'),
    path('subject/new/', login_required(views_subjects.SubjectNew.as_view()), name='subject_new'),
	path('subject/view/<int:pk>/', login_required(views_subjects.SubjectViewDetailView.as_view()), name='subject_view'),
	path('subject/edit/<int:pk>/', login_required(views_subjects.SubjectEditDetailView.as_view()), name='subject_edit'),
	
    path('subjectFn/<int:subject_id>/', views_subjects.subjectFn, name='subject_Fn'),
    path('subjectFnNew/', views_subjects.subjectFnNew, name='subject_FnNew'),
    
    # Sessions Views
    path('sessions/', login_required(views_sessions.SessionsView.as_view()), name='session_list'),
	path('sessions/view/<int:pk>/', login_required(views_sessions.SessionViewDetailView.as_view()), name='session_view'),

	path('sessions/add_subject/<int:session_id>/<int:subject_id>', views_sessions.SessionAddSubject, name='session_add_subject'),
	path('sessions/remove_subject/<int:session_id>/<int:subject_id>', views_sessions.SessionRemoveSubject, name='session_remove_subject'),
    path('sessions/choose_subject/<int:session_id>/<int:subject_id>', views_sessions.SessionChooseSubject, name='session_choose_subject'),
    
    path('sessions/quit_project/<int:session_id>/<int:project_id>', views_sessions.SessionQuitProject, name='session_quit_project'),
    path('sessions/validate_project/<int:session_id>/<int:project_id>', views_sessions.ProjectValidateTutor, name='project_validate_tutor'),
    path('sessions/validate_project_admin/<int:session_id>/<int:project_id>', views_sessions.ProjectValidateAdmin, name='project_validate_admin'),
    path('sessions/project_remove_student/<int:session_id>/<int:project_id>/<int:user_id>', views_sessions.ProjectRemoveStudent, name='project_remove_student'),
    path('sessions/project_add_student/<int:session_id>/<int:project_id>', views_sessions.ProjectAddStudent, name='project_add_student'),

    path('sessions/create_group_selection/<int:session_id>', views_sessions.CreateGroupSelection, name='create_group_selection'),
    path('sessions/join_group_selection/<int:session_id>/<int:group_id>', views_sessions.JoinGroupSelection, name='join_group_selection'),
    path('sessions/quit_group_selection/<int:session_id>/<int:group_id>', views_sessions.QuitGroupSelection, name='quit_group_selection'),
    path('sessions/save_group_selection/<int:session_id>/<int:group_id>', views_sessions.SaveGroupSelection, name='save_group_selection'),
    path('sessions/create_project_selection/<int:session_id>', views_sessions.CreateProjectSelection, name='create_project_selection'),
    path('sessions/step_project_selection/<int:session_id>', views_sessions.StepProjectSelection, name='step_project_selection'),
    path('sessions/all_step_project_selection/<int:session_id>', views_sessions.AllStepProjectSelection, name='all_step_project_selection'),
    path('sessions/random_ranking_project_selection/<int:session_id>', views_sessions.RandomRankingProjectSelection, name='random_ranking_project_selection'),
    path('sessions/init_order_project_selection/<int:session_id>', views_sessions.InitOrderProjectSelection, name='init_order_project_selection'),

    path('sessions/step_rank_rand_project_selection/<int:session_id>', views_sessions.StepRankRandProjectSelection, name='step_rank_rand_project_selection'),
    path('sessions/all_step_rank_rand_project_selection/<int:session_id>', views_sessions.AllStepRankRandProjectSelection, name='all_step_rank_rand_project_selection'),

    path('sessions/enable_ordering_project_selection/<int:session_id>', views_sessions.EnableOrderingProjectSelection, name='enable_ordering_project_selection'),
    path('sessions/load_ranking_project_selection/<int:session_id>', views_sessions.LoadRankingProjectSelection, name='load_ranking_project_selection'),

    path('sessions/generate_project_project_selection/<int:session_id>', views_sessions.GenerateProjectProjectSelection, name='generate_project_project_selection'),
    path('sessions/delete_project_selection/<int:session_id>/<int:projectsel_id>', views_sessions.DeleteProjectSelection, name='delete_project_selection'),



	path('sessions/new_report/<int:session_id>/<int:project_id>/<int:date_report_id>/', views_sessions.SessionReportNewView, name='session_report_new_view'),
    path('sessions/validate_report_tutor/<int:session_id>/<int:report_id>', views_sessions.ReportValidateTutor, name='report_validate_tutor'),

	path('sessions/new_deposit/<int:session_id>/<int:project_id>/<int:date_deposit_id>/', views_sessions.SessionDepositNewView, name='session_deposit_new_view'),
    path('sessions/validate_deposit_tutor/<int:session_id>/<int:deposit_id>', views_sessions.DepositValidateTutor, name='deposit_validate_tutor'),

	path('sessions/git/<int:session_id>/<int:project_id>/', views_sessions.SessionProjectGitView, name='session_project_git_view'),

    # Sessions Admin Views
    path('sessions/admin/<int:pk>/', login_required(views_sessions_admin.SessionAdminDetailView.as_view()), name='session_admin_view'),
    path('sessions/add_members/<int:session_id>/', views_sessions_admin.SessionAdminAddMembers, name='session_admin_add_members_view'),
    path('sessions/remove_members/<int:session_id>/<int:user_id>', views_sessions_admin.SessionAdminRemoveMembers, name='session_admin_remove_members_view'),
    path('sessions/change_description/<int:session_id>', views_sessions_admin.SessionAdminChangeDescription, name='session_admin_change_description_view'),
    path('sessions/change_phase/<int:session_id>', views_sessions_admin.SessionAdminChangePhase, name='session_admin_change_phase_view'),


    # Project Views
    path('projects/view/<int:pk>/', login_required(views_projects.ProjectViewDetailView.as_view()), name='project_view'),
    path('projects/validate_deposit_tutor/<int:project_id>/<int:deposit_id>', views_projects.DepositValidateTutorProject, name='deposit_validate_project'),
    path('projects/validate_report_tutor/<int:project_id>/<int:report_id>', views_projects.ReportValidateTutorProject, name='report_validate_project'),

    path('projects/testMail/<int:project_id>', views_projects.ReportTestMail, name='report_mail'),

    # Test Views
    path('testOrder/', views_tests.testOrder, name='testOrder')
]

sitePTUT/urls.py
from django.contrib import admin
from django.urls import include, path
from django.views.generic.base import TemplateView
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('gestion_projets/', include('gestion_projets.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('accounts.urls')),
	path('accounts/', include('django.contrib.auth.urls')),
	path('', TemplateView.as_view(template_name='home.html'), name='home'),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

gestion_projets/models.py
from django.db import models
from django.contrib.auth.models import User, Group

import os
import unidecode

# Tag for a project subject.
class Tag(models.Model):
    text = models.CharField(max_length=50)
    
    def __str__(self):
        return "%s" % (self.text)

# Technology for a project subject.
class Technology(models.Model):
    text = models.CharField(max_length=50)
    
    def __str__(self):
        return "%s" % (self.text)

# Subject for a project.
class Subject(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    
    title = models.CharField(max_length=100)
    description = models.TextField()
    
    technologies = models.ManyToManyField(Technology, blank=True)
    tags = models.ManyToManyField(Tag, blank=True)
    
    difficulty = models.IntegerField(default=0)
    
    motivation = models.TextField(blank=True, null=True)
    is_valid = models.BooleanField(default=False)

    nb_view = models.IntegerField(default=0)
    
    def __str__(self):
        return "%s" % (self.title)

# Session.
class Session(models.Model):
    session_name = models.CharField(max_length=100)
    description = models.TextField(default="")
    
    session_start = models.DateField()
    session_end = models.DateField()
    phase = models.IntegerField(default=0)
    modeGroup = models.IntegerField(default=0)
    enable_ordering = models.BooleanField(default=False)
    
    subjects = models.ManyToManyField(Subject, blank=True)
    group = models.ForeignKey(Group, on_delete=models.CASCADE, blank=True, null=True)

    student_can_submit = models.BooleanField(default=False)
    visibility = models.BooleanField(default=False)
    
    maximum_per_group = models.IntegerField(default=4)

    def __str__(self):
        return "%s, %s" % (self.session_name, self.session_start)
    
    class Meta:
        permissions = [
            ("submit_subject", "Can submit a subject"),
        ]

# Project for a session.
class Project(models.Model):
    session = models.ForeignKey(Session, on_delete=models.CASCADE)
    subject = models.ForeignKey(Subject, on_delete=models.CASCADE)
    
    users = models.ManyToManyField(User, blank=True)# check tutor or student
    
    is_valid_tutor = models.BooleanField(default=False)
    is_valid_admin = models.BooleanField(default=False)

    git_url = models.CharField(max_length=100, blank=True, null=True)
    
    def __str__(self):
        return "%s, Session[ %s ]" % (self.subject.title, self.session.session_name)


def content_file_name_DepositSession(instance, filename):
    ext = filename.split('.')[-1]
    filename = "%s.%s" % (instance.titleDeposit, ext)
    filename = unidecode.unidecode(filename)
    dir = "%s" % (instance.session.session_name)
    dir = dir.replace('/','-')
    dir = unidecode.unidecode(dir)
    return os.path.join('uploads', 'session', dir, filename)

# Deposit Session.
class DepositSession(models.Model):
    session = models.ForeignKey(Session, on_delete=models.CASCADE)
    
    titleDeposit = models.CharField(max_length=100)
    upload = models.FileField(upload_to=content_file_name_DepositSession, max_length=500)

    def __str__(self):
        return "%s, Session[ %s ]" % (self.titleDeposit, self.session.session_name)

# Step tasks.
class DateDeposit(models.Model):
    session = models.ForeignKey(Session, on_delete=models.CASCADE)
    
    title = models.CharField(max_length=100)
    description = models.TextField()
    date_limit = models.DateField()

    def __str__(self):
        return "%s, Session[ %s ]" % (self.title, self.session.session_name)

    class Meta:
        ordering = ['date_limit']

def content_file_name_Deposit(instance, filename):
    ext = filename.split('.')[-1]
    filename = "%s.%s" % (instance.dateDeposit.title, ext)
    filename = unidecode.unidecode(filename)
    dir_session = "%s" % (instance.project.session.session_name)
    dir_session = dir_session.replace('/','-')
    dir_project = "%s" % (instance.project.subject)
    dir_project = dir_project.replace('/','-')
    dir_project = dir_project.replace(' ','_')
    dir_project = unidecode.unidecode(dir_project)
    return os.path.join('uploads', 'session', dir_session, dir_project, filename)

class Deposit(models.Model):
    project = models.ForeignKey(Project, on_delete=models.CASCADE)
    dateDeposit = models.ForeignKey(DateDeposit, on_delete=models.CASCADE)
    user = models.ForeignKey(User, on_delete=models.CASCADE, null=True)
    
    description = models.TextField()
    
    upload = models.FileField(upload_to=content_file_name_Deposit, max_length=500)
    date_deposit = models.DateField(blank=True, null=True)

    is_valid = models.BooleanField(default=False)

    note = models.IntegerField(default=0)

    comment = models.TextField(blank=True, null=True)

    def __str__(self):
        return "%s, Project[ %s ], Session[ %s ]" % (self.date_deposit, self.project.subject.title, self.project.session.session_name)

# Step tasks.
class DateReport(models.Model):
    session = models.ForeignKey(Session, on_delete=models.CASCADE)
    date_limit = models.DateField(blank=True, null=True)

    def __str__(self):
        return "%s, Session[ %s ]" % (self.date_limit, self.session.session_name)

    class Meta:
        ordering = ['date_limit']

# Step tasks.
class Report(models.Model):
    project = models.ForeignKey(Project, on_delete=models.CASCADE)
    dateReport = models.ForeignKey(DateReport, on_delete=models.CASCADE)
    user = models.ForeignKey(User, on_delete=models.CASCADE, null=True)
    
    description = models.TextField()
    
    date_deposit = models.DateField(blank=True, null=True)
    is_valid = models.BooleanField(default=False)

    checkbox_contact = models.BooleanField(default=False)
    checkbox_task_previous = models.BooleanField(default=False)
    checkbox_task_next = models.BooleanField(default=False)
    checkbox_members = models.BooleanField(default=False)
    checkbox_time = models.BooleanField(default=False)

    comment = models.TextField(blank=True, null=True)

    def __str__(self):
        return "%s, Project[ %s ], Session[ %s ]" % (self.date_deposit, self.project.subject.title, self.project.session.session_name)

# Step tasks.
class ProjectSelection(models.Model):

    session = models.ForeignKey(Session, on_delete=models.CASCADE)

    users = models.ManyToManyField(User)
    order = models.TextField(blank=True, null=True)
    order_current = models.TextField(blank=True, null=True)

    date_creation = models.DateTimeField(blank=True, null=True)
    date_modification = models.DateTimeField(blank=True, null=True)

    ranking = models.IntegerField(default=0)
    random_number = models.FloatField(default=0.0)

    assigned = models.BooleanField(default=False)
    project_generated = models.BooleanField(default=False)
    
    def __str__(self):
        return "%s, Session[ %s ]" % (self.order, self.session.session_name)

gestion_projets/views/views_tests.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render, redirect
from django.urls import reverse
from django.views import generic
from django.http import JsonResponse
from django.contrib.auth.decorators import login_required

from django.utils import timezone

from ..models import Subject, Session, Project, DateDeposit, Deposit, DateReport, Report, User, ProjectSelection

from datetime import date

from django.core.mail import send_mail

import json



@login_required
def testOrder(request):# add session id and group
    data = request.POST.copy()
    selection = ProjectSelection.objects.create(order=data.get('order'))
    selection.save()
    # 'text,test'.split(',')

    return HttpResponse(
            json.dumps({"nothing to see": "this isn't happening"}),
            content_type="application/json"
        )
 

gestion_projets/templates/includes/phase2/simple/phase2_Admin.html
{% load gestion_projets_extras %}


<div class="remark primary">
    <p><b>Explication :</b> En tant qu'administrateur, vous devez vérifier que l'ensemble des étudiants ont un groupe et valider l'ensemble des sujets avant de passer à l'étape suivante.</p>
</div>
<!-- Affichage tous les projets -->
<div class="p-5">
    <table id="table_admin_projects" class="table">
        <thead>
        <tr>
            <th>Sujet</th>
            <th>Tuteur</th>
            <th>Membres</th>
            <th>Nombre</th>
            <th>Validation tuteur</th>
            <th>Validation admin</th>
        </tr>
        </thead>
        {% for project in session.project_set.all %}
            <tr>
                <td>{{ project.subject.title }}</td>
                <td>{{ project.subject.user.first_name }} {{ project.subject.user.last_name }}</td>
                <td>
                    {% for userProject in project.users.all %}
                        {{ userProject.first_name }} {{ userProject.last_name }}
                        <a class="button primary square mini warning" title="Enlever l'étudiant du projet" href="{% url 'gestion_projets:project_remove_student' session.id project.id userProject.id %}">
                            <span class="mif-cross icon"></span>,
                        </a>
                    {% endfor %}<BR>
                    <form action="{% url 'gestion_projets:project_add_student' session.id project.id %}" method="POST">
                        {% csrf_token %}
                        <select name="student" data-role="select">
                            <option disabled selected> -- Choisissez un étudiant -- </option>
                            {% for rem_student in remaining_student.all %}
                                <option value="{{ rem_student.id }}">{{ rem_student.first_name }} {{ rem_student.last_name }}</option>
                            {% endfor %}
                        </select>

                        <button class="image-button warning" title="Ajouter l'étudiant au projet" type="submit">
                            <span class="mif-add icon"></span>
                            <span class="caption">Ajouter</span></center>
                        </button>
                    </form>
                <td>{{ project.users.count }}/4<br></td>
                <td>
                    {% if project.is_valid_tutor %}
                        <span class="pr-10-md mif-checkmark mif-2x fg-green"></span>
                    {% else %}
                        <span class="pr-10-md mif-cross mif-2x fg-red"></span>
                    {% endif %}
                    <a class="button" href="{% url 'gestion_projets:project_validate_tutor' session.id project.id %}">Modifier</a>
                </td>
                <td>            
                    {% if project.is_valid_admin %}
                        <span class="pr-10-md mif-checkmark mif-2x fg-green"></span>
                    {% else %}
                        <span class="pr-10-md mif-cross mif-2x fg-red"></span>
                    {% endif %}
                    <a class="button" href="{% url 'gestion_projets:project_validate_admin' session.id project.id %}">Modifier</a></td>
            </tr>
        {% endfor %}
    </table>
</div>


<div class="remark primary">
    <p><b>Explication :</b> Il ne doit rester aucun étudiant pour démarrer la session suivante.</p>
</div>
<!-- Affichage tous les projets du tuteur -->
<div class="p-5">
    <table class="table">
        <thead>
        <tr>
            <th>Nom</th>
            <th>Prénom</th>
        </tr>
        </thead>
        {% for rem_student in remaining_student.all %}
            <tr>
                <td>{{ rem_student.first_name }} </td>
                <td>{{ rem_student.last_name }}</td>
            </tr>
        {% endfor %}
    </table>
</div>

gestion_projets/templates/includes/phase2/simple/phase2_Student.html
{% load gestion_projets_extras %}

<div class="remark primary">
    <p><b>Explication :</b> En tant qu'étudiant, vous devez choisir un sujet et constituer un groupe de 3 à 4 personnes.</p>
    <p><b>Contrainte :</b> Vous ne pouvez choisir qu'un seul groupe.</p>
    <p><b>Tâches :</b><br> 1/ Choisir un sujet et votre groupe<br> 2/ Aller voir le tuteur pour valider avec lui le sujet<br> 3/ Un problème : contacter le responsable des projets </p>
</div>
<div class="grid">
    <div class="row p-5">
        <div class="cell-lg-6">
            <!-- Liste des sujets -->
            <table class="table">
                <thead>
                <tr>
                    <th>Liste des sujets</th>
                    <th>Tuteur</th>
                    <th>Nombre</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
                {% for subject in session.subjects.all %}
                    <tr >
                        <td>{{ subject.title }}</td>
                        <td> {{ subject.user.first_name }} {{ subject.user.last_name }}</td>
                        <td> 
                            {{ subject|count_user:session }} / 4
                        </td>
                        <td> 
                            <form action="{% url 'gestion_projets:session_choose_subject' session.id subject.id %}" method="POST">
                                {% csrf_token %}
                                <a class="image-button success" title="Voir en détail le sujet" target="_blank" href="{% url 'gestion_projets:subject_view' subject.id %}"><center>
                                    <span class="mif-file-text icon"></span>
                                    <span class="caption">Voir</span></center>
                                </a>
                                <!-- Si l'utilisateur n'a pas de projet sélectionné -->
                                {% if project_user.count == 0 %}
                                    <!-- Si le sujet est libre (non validé) -->
                                    {% if subject|is_subject_open:session %} 
                                        <button class="image-button warning" title="Choisir ce sujet" type="submit">
                                            <span class="mif-arrow-right icon"></span>
                                            <span class="caption">Choisir</span></center>
                                        </button>
                                    {% endif %}
                                {% endif %}
                            </form>
                        </td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
        </div>
        <div class="cell-lg-6">
            <!-- Affichage du projet courant -->
            {% if project_user.count == 0 %}
                <div class="remark warning"><p>Choisir un sujet parmi la liste</p></div>
            {% else %}

            {% if project_user.count > 1 %}
                <div class="remark warning">Erreur : Nombre de projets sélectionnés trop important</div>
            {% endif %}
            <table class="table">
                <thead>
                <tr>
                    <th>Votre choix</th>
                    <th>Action</th>
                </tr>
                </thead>
                {% for project in project_user %}
                <tr>
                    <td>
                        <b>Titre :</b> {{ project.subject.title }}<br>
                        <b>Tuteur :</b> {{ project.subject.user.first_name }} {{ project.subject.user.last_name }}<br>
                        <b>Membres du projet:</b>
                        <ul>
                        {% for userProject in project.users.all %}
                            <li>{{ userProject.first_name }} {{ userProject.last_name }}</li>
                        {% endfor %}
                        </ul>
                        <b>Nombre des membres :</b> {{ project.users.count }}<br>
                        <b>Validation Tuteur : </b> 
                        {% if project.is_valid_tutor %}
                            <span class="pl-10-md mif-checkmark mif-2x fg-green"></span>
                        {% else %}
                            <span class="pl-10-md mif-cross mif-2x fg-red"></span>
                        {% endif %}<br>
                        <b>Validation Responsable : </b> 
                        {% if project.is_valid_admin %}
                            <span class="pl-10-md mif-checkmark mif-2x fg-green"></span>
                        {% else %}
                            <span class="pl-10-md mif-cross mif-2x fg-red"></span>
                        {% endif %}<br>
                        {% if project.users.count > 4 %}<!-- TODO : modifier la valeur 1 -->
                            <div class="remark warning">Nombre de personnes trop importantes</div>
                        {% endif %}
                    </td>
                    <td>
                        <form action="{% url 'gestion_projets:session_quit_project' session.id project.id %}" method="POST">
                            {% csrf_token %}
                            <a class="image-button success" title="Voir en détail le sujet" target="_blank" href="{% url 'gestion_projets:subject_view' project.subject.id %}"><center>
                                <span class="mif-file-text icon"></span>
                                <span class="caption">Voir</span></center>
                            </a>
                            {% if not project.is_valid_tutor and not project.is_valid_admin%}
                            <button class="image-button warning" title="Quitter ce projet" type="submit">
                                <span class="mif-arrow-left icon"></span>
                                <span class="caption">Quitter</span></center>
                            </button>
                            {% endif %}
                        </form>
                    </td>
                </tr>
                {% endfor %}
            </table>
            {% endif %}
        </div>
    </div>
</div>

gestion_projets/templates/includes/phase2/simple/phase2_Tutor.html
{% load gestion_projets_extras %}


<div class="remark primary">
    <p><b>Explication :</b> En tant que tuteur, vous devez valider les groupes des étudiants sur votre sujet.</p>
</div>
<div class="grid">
    <div class="row p-5">
    {% for project in session.project_set.all %}
        {% if project.subject.user == user %}
        <div class="cell-lg-6">
            <!-- Affichage tous les projets du tuteur -->
            <table class="table">
                <thead>
                <tr>
                    <th>Votre sujet</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tr>
                    <td>
                        <b>Titre :</b> {{ project.subject.title }}<br>
                        <b>Tuteur :</b> {{ project.subject.user.first_name }} {{ project.subject.user.last_name }}<br>
                        <b>Membres du projet:</b>
                        <ul>
                        {% for userProject in project.users.all %}
                            <li>{{ userProject.first_name }} {{ userProject.last_name }}</li>
                        {% endfor %}
                        </ul>
                        <b>Nombre des membres :</b> {{ project.users.count }} / 4<br>
                        <b>Validation Tuteur : </b> 
                        {% if project.is_valid_tutor %}
                            <span class="pl-10-md mif-checkmark mif-2x fg-green"></span>
                        {% else %}
                            <span class="pl-10-md mif-cross mif-2x fg-red"></span>
                        {% endif %}<br>
                        <b>Validation Responsable : </b> 
                        {% if project.is_valid_admin %}
                            <span class="pl-10-md mif-checkmark mif-2x fg-green"></span>
                        {% else %}
                            <span class="pl-10-md mif-cross mif-2x fg-red"></span>
                        {% endif %}<br>
                        {% if project.users.count > 4 %}<!-- TODO : modifier la valeur 1 -->
                            <div class="remark warning">Nombre de personnes trop importantes</div>
                        {% endif %}
                    </td>
                    <td>
                        {% if project.is_valid_tutor %}
                            <a class="image-button warning" title="Anuler la validation du sujet" href="{% url 'gestion_projets:project_validate_tutor' session.id project.id %}"><center>
                                <span class="mif-cross icon"></span>
                                <span class="caption">Annuler Validation</span></center>
                            </a>
                        {% else %}
                            <a class="image-button warning" title="Valider le sujet" href="{% url 'gestion_projets:project_validate_tutor' session.id project.id %}"><center>
                                <span class="mif-checkmark icon"></span>
                                <span class="caption">Valider</span></center>
                            </a>
                        {% endif %}

                    </td>
                </tr>
            </table>
        </div>
        {% endif %}
    {% endfor %}
    </div>
</div>